## qtalicevision 2025.1.0

=== CMakeLists.txt ===
message("CMake version: ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}")
cmake_minimum_required(VERSION 3.11)
project(QtAliceVisionPlugin LANGUAGES CXX VERSION 0.1.0)


# Build options
option(BUILD_IMAGEIO "Build qtAliceVisionImageIO plugin" ON)
option(BUILD_DEPTHMAPENTITY "Build depthMapEntity plugin" ON)
option(BUILD_SFM "Build qtAliceVision and qmlSfmData plugin" ON)

message(STATUS "BUILD_IMAGEIO: ${BUILD_IMAGEIO}")
message(STATUS "BUILD_DEPTHMAPENTITY: ${BUILD_DEPTHMAPENTITY}")
message(STATUS "BUILD_SFM: ${BUILD_SFM}")


# CMake Find modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)


# C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)


# Qt
find_package(Qt6Core REQUIRED)
find_package(Qt6Quick REQUIRED)
find_package(Qt6Qml REQUIRED)
find_package(Qt6Charts REQUIRED)
find_package(Qt6Gui REQUIRED)
find_package(Qt6 COMPONENTS ShaderTools)


set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
add_definitions(-DQT_PLUGIN)
add_definitions(-DQT_SHARED)
add_definitions(-DQT_NO_DEBUG)
add_definitions(-DQT_NO_KEYWORDS)

# comment to get qDebug outputs
add_definitions(-DQT_NO_DEBUG_OUTPUT)

# for performance reasons let Qt handle jpeg, png and ico formats
add_definitions(-DQT_ALICEVISIONIMAGEIO_USE_FORMATS_BLACKLIST)


# AliceVision dependency
find_package(AliceVision REQUIRED)


# Builds
add_subdirectory(src)

=== src/CMakeLists.txt ===
if(BUILD_IMAGEIO)
    add_subdirectory(qtAliceVisionImageIO)
endif()

if(BUILD_DEPTHMAPENTITY)
    add_subdirectory(depthMapEntity)
endif()

if(BUILD_SFM)
    add_subdirectory(qtAliceVision)
    add_subdirectory(qmlSfmData)
endif()

=== src/depthMapEntity/CMakeLists.txt ===
# Target srcs
set(PLUGIN_SOURCES
    DepthMapEntity.cpp
    )

set(PLUGIN_HEADERS
    plugin.hpp
    DepthMapEntity.hpp
    )


# Qt module dependency
find_package(Qt6 COMPONENTS Gui REQUIRED)
find_package(Qt6 COMPONENTS Qml REQUIRED)
find_package(Qt6 COMPONENTS Quick REQUIRED)
find_package(Qt6 COMPONENTS 3DCore REQUIRED)
find_package(Qt6 COMPONENTS 3DRender REQUIRED)
find_package(Qt6 COMPONENTS 3DExtras REQUIRED)


# OpenImageIO dependency
find_package(OpenImageIO REQUIRED)


# Target properties
add_library(depthMapEntityPlugin SHARED ${PLUGIN_SOURCES} ${PLUGIN_HEADERS})

if(MSVC)
    target_compile_options(depthMapEntityPlugin PUBLIC /W4)
else()
    target_compile_options(depthMapEntityPlugin PUBLIC -Wall -Wextra -Wconversion -Wsign-conversion -Wshadow -Wpedantic)
endif()

target_include_directories(depthMapEntityPlugin 
    PUBLIC 
    ${OPENIMAGEIO_INCLUDE_DIRS}
    )

target_link_libraries(depthMapEntityPlugin
      PUBLIC
      ${OPENIMAGEIO_LIBRARIES}
      aliceVision_image
      aliceVision_mvsData
      aliceVision_numeric
      Qt6::Core
      Qt6::Gui
      Qt6::Qml
      Qt6::Quick
      Qt6::3DCore
      Qt6::3DRender
      Qt6::3DExtras
      )

set_target_properties(depthMapEntityPlugin
      PROPERTIES
      DEBUG_POSTFIX ""
      FOLDER "depthMapEntityPlugin"
      $SOVERSION ${PROJECT_VERSION_MAJOR}
      VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
      )


# Install settings
install(FILES "qmldir"
        DESTINATION ${CMAKE_INSTALL_PREFIX}/qml/DepthMapEntity)
install(TARGETS depthMapEntityPlugin
        DESTINATION "${CMAKE_INSTALL_PREFIX}/qml/DepthMapEntity")

=== src/qmlSfmData/CMakeLists.txt ===
# Target srcs
set(PLUGIN_SOURCES
    IOThread.cpp
    SfmDataEntity.cpp
    CameraLocatorEntity.cpp
    PointCloudEntity.cpp
)

set(PLUGIN_HEADERS
    IOThread.hpp
    plugin.hpp
    SfmDataEntity.hpp
    CameraLocatorEntity.hpp
    PointCloudEntity.hpp
)

# Qt module dependency
find_package(Qt6 COMPONENTS Qml REQUIRED)
find_package(Qt6 COMPONENTS 3DCore REQUIRED)
find_package(Qt6 COMPONENTS 3DRender REQUIRED)
find_package(Qt6 COMPONENTS 3DExtras REQUIRED)

# Target properties
add_library(sfmDataEntityQmlPlugin SHARED ${PLUGIN_SOURCES} ${PLUGIN_HEADERS})

if(MSVC)
    target_compile_options(sfmDataEntityQmlPlugin PUBLIC /W4)
else()
    target_compile_options(sfmDataEntityQmlPlugin
        PUBLIC
        -Wall -Wextra -Wconversion -Wsign-conversion -Wshadow -Wpedantic
    )
endif()

target_link_libraries(sfmDataEntityQmlPlugin
    PUBLIC
        Qt6::Core
        Qt6::Qml
        Qt6::3DCore
        Qt6::3DRender
        aliceVision_sfmDataIO
        aliceVision_sfm
        aliceVision_system
    PRIVATE
        Qt6::3DExtras
)

set_target_properties(sfmDataEntityQmlPlugin
    PROPERTIES
    DEBUG_POSTFIX ""
    FOLDER "sfmDataEntityQmlPlugin"
    SOVERSION ${PROJECT_VERSION_MAJOR}
    VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
)

# Install settings
install(FILES "qmldir"
        DESTINATION ${CMAKE_INSTALL_PREFIX}/qml/SfmDataEntity)
install(TARGETS sfmDataEntityQmlPlugin
        DESTINATION "${CMAKE_INSTALL_PREFIX}/qml/SfmDataEntity")

=== src/qtAliceVision/CMakeLists.txt ===
# Target srcs
set(PLUGIN_SOURCES
    FeaturesViewer.cpp
    MFeatures.cpp
    MSfMData.cpp
    MViewStats.cpp
    MTracks.cpp
    FloatImageViewer.cpp
    FloatTexture.cpp
    Surface.cpp
    MSfMDataStats.cpp
    PanoramaViewer.cpp
    PhongImageViewer.cpp
    Painter.cpp
    SequenceCache.cpp
    SingleImageLoader.cpp
    ImageCache.cpp
    AsyncFetcher.cpp
    )

set(PLUGIN_HEADERS
    plugin.hpp
    FeaturesViewer.hpp
    MFeatures.hpp
    MSfMData.hpp
    MTracks.hpp
    MViewStats.hpp
    FloatImageViewer.hpp
    FloatTexture.hpp
    MSfMDataStats.hpp
    PanoramaViewer.hpp
    PhongImageViewer.hpp
    Surface.hpp
    Painter.hpp
    ImageServer.hpp
    SequenceCache.hpp
    SingleImageLoader.hpp
    ImageCache.hpp
    AsyncFetcher.hpp
    
    )

set(PLUGIN_MOCS
    FeaturesViewer.hpp
    MFeatures.hpp
    MSfMData.hpp
    MViewStats.hpp
    MTracks.hpp
    MSfMDataStats.hpp
    SequenceCache.hpp
    SingleImageLoader.hpp
    AsyncFetcher.hpp
    )


# Qt module dependency
find_package(Qt6 COMPONENTS Quick REQUIRED)
find_package(Qt6 COMPONENTS Qml REQUIRED)
find_package(Qt6 COMPONENTS Charts REQUIRED)
find_package(Qt6 REQUIRED COMPONENTS Gui)
find_package(Qt6 COMPONENTS ShaderTools)


# Target properties
add_library(qtAliceVisionPlugin SHARED ${PLUGIN_SOURCES} ${PLUGIN_HEADERS} ${PLUGIN_MOCS})


if(MSVC)
    target_compile_options(qtAliceVisionPlugin PUBLIC /W4)
else()
    target_compile_options(qtAliceVisionPlugin PUBLIC -Wall -Wextra -Wconversion -Wsign-conversion -Wshadow -Wpedantic)
endif()

find_package(Qt6 COMPONENTS ShaderTools)
qt6_add_shaders(qtAliceVisionPlugin "qtAliceVisionPlugin_shaders"
    BATCHABLE
    PRECOMPILE
    OPTIMIZED
    PREFIX "/shaders"
    FILES FloatImageViewer.vert FloatImageViewer.frag
          FeaturesViewer.vert FeaturesViewer.frag
          PhongImageViewer.vert PhongImageViewer.frag
          ImageOverlay.frag
          AttributeItemDelegate.frag
    )

target_link_libraries(qtAliceVisionPlugin
  PUBLIC
    aliceVision_feature
    aliceVision_sfmDataIO
    aliceVision_sfm
    aliceVision_system
    aliceVision_image
    Qt6::Core
    Qt6::Qml
    Qt6::Quick
    Qt6::Charts
    Qt6::GuiPrivate
)

set_target_properties(qtAliceVisionPlugin
        PROPERTIES
        DEBUG_POSTFIX ""
        FOLDER "qtAliceVisionPlugin"
        SOVERSION ${PROJECT_VERSION_MAJOR}
        VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
        )


# Install settings
install(FILES "qmldir"
        DESTINATION ${CMAKE_INSTALL_PREFIX}/qml/AliceVision)
install(TARGETS qtAliceVisionPlugin
        DESTINATION "${CMAKE_INSTALL_PREFIX}/qml/AliceVision")

=== src/qtAliceVisionImageIO/CMakeLists.txt ===
# Target srcs
set(PLUGIN_SOURCES
    plugin.cpp
    QtAliceVisionImageIOHandler.cpp
    )

set(PLUGIN_HEADERS
    plugin.hpp
    QtAliceVisionImageIOHandler.hpp
    )


# Qt module dependencies
find_package(Qt6 COMPONENTS Gui REQUIRED)


# OpenImageIO dependency
find_package(OpenImageIO REQUIRED)


# Target properties
add_library(qtAliceVisionImageIOPlugin SHARED ${PLUGIN_SOURCES} ${PLUGIN_HEADERS})

if(MSVC)
    target_compile_options(qtAliceVisionImageIOPlugin PUBLIC /W4)
else()
    target_compile_options(qtAliceVisionImageIOPlugin
        PUBLIC
        -Wall -Wextra -Wconversion -Wsign-conversion -Wshadow -Wpedantic
        )
endif()

target_include_directories(qtAliceVisionImageIOPlugin 
    PUBLIC 
    ${OPENIMAGEIO_INCLUDE_DIRS}
    )

target_link_libraries(qtAliceVisionImageIOPlugin
    PUBLIC
    ${OPENIMAGEIO_LIBRARIES}
    aliceVision_image
    Qt6::Core
    Qt6::Gui
    )


# Install settings
install(TARGETS qtAliceVisionImageIOPlugin DESTINATION imageformats)

=== debian/changelog ===
qtalicevision (2025.1.0-1) unstable; urgency=medium

  * Initial release into Debian (Closes: #1111933)

 -- Dima Kogan <dkogan@debian.org>  Sat, 23 Aug 2025 17:05:24 -0700

=== debian/control ===
Source: qtalicevision
Section: contrib/libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               qt6-base-dev,
               qt6-base-private-dev,
               qt6-declarative-dev,
               qt6-charts-dev,
               qt6-shadertools-dev,
               qt6-3d-dev,
               openimageio-tools,
               libalicevision-dev
Standards-Version: 4.6.0
Homepage: https://github.com/alicevision/QtAliceVision
Vcs-Git: https://salsa.debian.org/science-team/QtAliceVision.git
Vcs-Browser: https://salsa.debian.org/science-team/QtAliceVision

Package: qml-module-alicevision
Section: contrib/libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: QML bindings for AliceVision
 Classes to load and visualize AliceVision data through QML. Makes the
 AliceVision backend available via the Meshroom frontend

Package: qt6-alicevision-oiio-plugins
Section: contrib/libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Qt6 AliceVision library plugins
  An OpenImageIO backend for image IO in Qt:
    - Read RAW images from DSLRs
    - Read intermediate files of the AliceVision framework stored in EXR format

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem cmake

=== debian/watch ===
version=4
opts=\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/QtAliceVision-$1\.tar\.gz/ \
 https://github.com/alicevision/QtAliceVision/tags .*/v?(\d\S+)\.tar\.gz

## qtalicevision 2025.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,8 +17,8 @@
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 
 
-# C++17
-set(CMAKE_CXX_STANDARD 17)
+# C++20
+set(CMAKE_CXX_STANDARD 20)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)

=== debian/changelog ===
qtalicevision (2025.1.1-1ubuntu1) resolute; urgency=medium

  * Add fix-build-with-Qt-6.10.patch

 -- Rik Mills <rikmills@kde.org>  Fri, 20 Feb 2026 12:52:21 +0000

qtalicevision (2025.1.1-1build1) resolute; urgency=medium

  * No-change rebuild for Qt 6.10.2 private ABI.

 -- Rik Mills <rikmills@kde.org>  Fri, 20 Feb 2026 11:33:04 +0000

qtalicevision (2025.1.1-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Sat, 20 Dec 2025 18:26:26 -0800

qtalicevision (2025.1.0-2) unstable; urgency=medium

  * Rebuild for qt6 6.9.2

 -- Dima Kogan <dkogan@debian.org>  Wed, 26 Nov 2025 17:39:15 -0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: qtalicevision
 Section: contrib/libs
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cmake,
